require "json"

package = JSON.parse(File.read(File.join(__dir__, "package.json")))
#default version
firebase_sdk_version = "10.22.0"

Pod::Spec.new do |s|
  s.name         = "react-native-firebase-analytics"
  s.version      = package["version"]
  s.summary      = package["description"]
  s.homepage     = package["homepage"]
  s.license      = package["license"]
  s.authors      = package["author"]

  s.platforms    = { :ios => "11.0" }
  s.source       = { :git => "https://ussvc01.newsmemory.com:3000/tecnavia/react-native-firebase-analytics.git", :tag => "#{s.version}" }

  s.source_files = "ios/**/*.{h,m,mm}"

  s.dependency "React-Core"

  if defined?($FirebaseSDKVersion)
    Pod::UI.puts "#{s.name}: Using user specified Firebase SDK version '#{$FirebaseSDKVersion}'"
    firebase_sdk_version = $FirebaseSDKVersion
  end

  # Firebase dependencies
  if defined?($RNFirebaseAnalyticsWithoutAdIdSupport)
    Pod::UI.puts "#{s.name}: Using Firebase/AnalyticsWithoutAdIdSupport pod in place of default Firebase/Analytics"

    # Releasing as non-breaking change as it is optional but it raises minimum requirements, validate just in case
    if (Gem::Version.new(firebase_sdk_version) < Gem::Version.new("7.11.0"))
      raise "Firebase/AnalyticsWithoutAdIdSupport requires firebase-ios-sdk 7.11.0 or greater."
    end

    s.dependency          'Firebase/AnalyticsWithoutAdIdSupport', firebase_sdk_version
  else
    Pod::UI.puts "#{s.name}: Using default Firebase/Analytics with Ad Ids. May require App Tracking Transparency. Not allowed for Kids apps."
    Pod::UI.puts "#{s.name}: You may set variable `$RNFirebaseAnalyticsWithoutAdIdSupport=true` in Podfile to use analytics without ad ids."
    s.dependency          'Firebase/Analytics', firebase_sdk_version
  end

  if defined?($RNFirebaseAsStaticFramework)
    Pod::UI.puts "#{s.name}: Using overridden static_framework value of '#{$RNFirebaseAsStaticFramework}'"
    s.static_framework = $RNFirebaseAsStaticFramework
  else
    s.static_framework = false
  end
end
